unsigned char send_pkt(unsigned char __far *buff, unsigned len);
#pragma aux send_pkt = \
  "push ds" \
  "mov ds, dx" \
  "mov ah, 4" \
  "push cx" \
  "int 0x60" \
  "pop cx" \
  "jnc end" \
  "mov al, dh" \
  "inc cs:tx_error_count" \
  "jmp end2" \
  "end:" \
  "xor al, al" \
  "inc cs:tx_packets" \
  "add word ptr cs:tx_bytes, cx" \
  "adc word ptr cs:tx_bytes+2, 0" \
  "end2:" \
  "pop ds" \
  parm [dx si] [cx] value [al];

unsigned char send_pkt_as(unsigned char __far *buff);
#pragma aux send_pkt_as = \
  "push dx" \
  "mov ah, 12" \
  "inc cs:transmission_flag" \
  "push cx" \
  "int 0x60" \
  "pop cx" \
  "jnc end" \
  "mov al, dh" \
  "dec cs:transmission_flag" \
  "jmp end2" \
  "end:" \
  "xor al, al" \
  "inc cs:tx_packets" \
  "add word ptr cs:tx_bytes, cx" \
  "adc word ptr cs:tx_bytes+2, 0" \
  "end2:" \
  "pop dx" \
  parm [es di] value [al];

static unsigned char send_pkt_nonblock(char __far *buff, unsigned length)
{
  unsigned char __far *strct;
  unsigned n = driver.max_sends;
  #define transmit_buffer *(char __far* __far*)&strct[0]
  #define transmit_length *(unsigned __far*)&strct[4]
  #define transmit_flags strct[6]
  #define transmit_upcall *(void __far* __far*)&strct[8]

  while(n--)
  {
    strct = &out_pkt_buffs[n][OUT_PACKET_SIZE];
    if(transmit_flags & 1) break;
  }

  _fmemcpy(out_pkt_buffs[n], buff, OUT_PACKET_SIZE);

  transmit_buffer = out_pkt_buffs[n];
  transmit_length = length;
  transmit_flags = 2;
  transmit_upcall = (void __far*)upcall;

  return send_pkt_as(strct);
}

static int transmit_not_ready(void)
{
  return (transmission_flag == driver.max_sends);
}

int transmit_block(void);
#pragma aux transmit_block value [ax];
int transmit_block(void)
{
  if(!driver.hi_perf) return 0;
  return transmit_not_ready();
}

static unsigned char __far *get_free_async_buff(void)
{
  unsigned n;
  unsigned char __far *strct;

  if(!driver.hi_perf)
    return out_pkt_buffs[0];

  while(transmit_not_ready());

  for(n=driver.max_sends;n--;)
  {
    strct = &out_pkt_buffs[n][OUT_PACKET_SIZE];
    if(transmit_flags & 1) break;
  }
  return out_pkt_buffs[n];
}

static struct incoming_packet parse_packet(struct raw_packet );

struct loopback __based(__segname("_CODE")) loopback;

static int loopback_pkt(unsigned char __far *buff, unsigned len)
{
  if(loopback.has_data) return 1;
  loopback.packet.length = len;  
  _fmemcpy(loopback.packet.data, buff, len);
  loopback.has_data = 1;
  loopback.processing = 0;
  return 0;
}

extern unsigned char __based(__segname("_CODE")) bios_dmaio_in_progress;

static unsigned char send_raw_packet(unsigned char __far *buff, unsigned len)
{
  if(bios_dmaio_in_progress) return 1;

  #ifndef DISABLE_HIPERF
  if(driver.hi_perf)
    return send_pkt_nonblock(buff, len);
  else
  #endif
    return send_pkt(buff, len);
}

static unsigned char send_ip_packet(unsigned char __far *buff, unsigned len)
{
  unsigned char __far *ip_header = &buff[14];
  if(ip_header[16] != 127)
  {
    if(len < 60)
    {
      // assume the buffer is OUT_PACKET_SIZE long
      _fmemset(&buff[len], 0, 60-len);
      len = 60;
    }
    return send_raw_packet(buff, len);
  }
  else
  {
    ip_header[12] = 127; // to indicate that this packet is from localhost
    return loopback_pkt(buff, len);
  }
}

unsigned get_my_mac(unsigned char __far *buff);
#pragma aux get_my_mac = \
  "push dx" \
  "mov ah, 6" \
  "mov bx, 0" \
  "mov cx, 6" \
  "int 0x60" \
  "jnc end" \
  "mov ah, dh" \
  "jmp end2" \
  "end:" \
  "mov ah, 0" \
  "end2:" \
  "mov ax, cx" \
  "pop dx" \
  parm [es di] value [ax];

void __far *allocate_input_buffer(unsigned paragraphs);
#pragma aux allocate_input_buffer = \
  "push bx" \
  "mov ah, 0x48" \
  "int 0x21" \
  "jnc success" \
  "xor ax, ax" \
  "xor dx, dx" \
  "jmp fail" \
  "success:" \
  "mov dx, ax" \
  "dec dx" \
  "mov ax, 0x10" \
  "fail:" \
  "pop bx" \
  value [dx ax] parm [bx];

static int packet_ready(void)
{
  unsigned n = RAW_PACKET_COUNT;
  while(n--)
    if(raw_packet[n].data)
      break;
  return n;
}

void __far *get_parameters(void);
#pragma aux get_parameters = \
  "mov ah, 10" \
  "int 0x60" \
  "jnc end" \
  "xor di, di" \
  "mov es, di" \
  "end:" \
  value [es di];


static int get_driver_info(void)
{
//  union REGS regs;
//  struct SREGS sregs;
  unsigned version;
  unsigned type;
  char class;
  char number;
  char functionality;
  char *driver_name;
  unsigned name_segment;
  unsigned char __far *ptr;
  unsigned n;

/*  regs.h.ah = 1;
  regs.h.al = 255;
  regs.w.bx = 0;*/

//  int86x(0x60, &regs, &regs, &sregs);
  __asm
  {
    push ds
    mov ah, 1
    mov al, 255
    mov bx, 0
    int 0x60
    mov version, bx
    mov type, dx
    mov class, ch
    mov number, cl
    mov functionality, al
    mov driver_name, si
    mov name_segment, ds
    pop ds
  }

/*  driver.version = regs.w.bx;
  driver.type = regs.w.dx;
  driver.class = regs.h.ch;
  driver.number = regs.h.cl;
  driver.functionality = regs.h.al;*/

//  _fstrncpy(driver.name, MK_FP(sregs.ds, regs.w.si), 64);

  driver.version = version;
  driver.type = type;
  driver.class = class;
  driver.number = number;
  driver.functionality = functionality;
  _fstrncpy(driver.name, MK_FP(name_segment, driver_name), 64);

  if(driver.functionality & 0x04)
  {
    ptr = get_parameters();
    if(ptr)
    {
      driver.spec_major = ptr[0];
      driver.spec_minor = ptr[1];
      printf("Driver's specification version is %u.%.2u\n", driver.spec_major, driver.spec_minor);
      if((driver.spec_major == 1 && driver.spec_minor >= 10) || driver.spec_major > 1)
      {
        driver.hi_perf = 1;
        driver.max_sends = 1 + *(unsigned __far*)&ptr[10];

        printf("Max async sends: %u\n", driver.max_sends);

        if(driver.max_sends < MAX_HIPERF_OUTPACKET_BUFFERS)
          n = driver.max_sends;
        else
        {
          n = MAX_HIPERF_OUTPACKET_BUFFERS;
          driver.max_sends = n;
        }
        while(n--)
        {
          out_pkt_buffs[n] = tcpmalloc(OUT_PACKET_SIZE+24);
          if(!FP_SEG(out_pkt_buffs[n])) // disable hi-performance functionality
          {                     // when out of memory
            do
              ffree(out_pkt_buffs[n]);
            while(++n < MAX_HIPERF_OUTPACKET_BUFFERS);
            driver.hi_perf = 0;
            goto low_perf;
          }
          out_pkt_buffs[n][OUT_PACKET_SIZE+6] = 1;
        }
        return 0;
      }
    }
  }
  low_perf:
  driver.max_sends = 1;
  out_pkt_buffs[0] = tcpmalloc(OUT_PACKET_SIZE);
  if(!FP_SEG(out_pkt_buffs[0]))
    return 1;
  return 0;
}


//void __far * __far receiver(unsigned phase, unsigned length);

static void set_receiver(void)
{
  union REGS regs;
  struct SREGS sregs;
  unsigned char class = driver.class;
  unsigned type = driver.type;
  unsigned char number = driver.number;
//  unsigned packet_seg = FP_SEG(packet_type); // not needed
  #ifndef ARP
  static char __based (__segname("_CODE")) packet_type[2] = { 0x08, 0x00 }; // IP packets  
  unsigned packet_off = FP_OFF(packet_type);
  #endif
  unsigned receiver_seg = FP_SEG(receiver_wrapper);
  unsigned receiver_off = FP_OFF(receiver_wrapper);
  unsigned handle;
  unsigned char error = 0;

  __asm
  {
    push ds
    mov bx, type
    mov dl, number
  #ifndef ARP    
    mov cx, 2
    mov si, packet_off
  #else
    mov cx, 0
  #endif
    mov ax, cs
    mov ds, ax
    mov es, receiver_seg
    mov al, class
    mov ah, 2
    mov di, receiver_off
    int 0x60
    jnc noerror
    mov error, dh
    noerror:
    mov handle, ax
    pop ds
  }

  if(error)
  {
    printf("Error %u\n", (unsigned short)error);
    exit(0);
  }

  driver.handle = handle;
}

static void release_type(void)
{
  unsigned handle = driver.handle;

  __asm
  {
    mov ah, 7
    mov bx, handle
    int 0x60
    mov ah, 3
    mov bx, handle
    int 0x60    
  }
}
